#include "maspcm.h"

void MAS_Freeze( void )
{
	const unsigned char freeze[]   = { 0x00, 0x00 };
	const unsigned char stopdma1[] = { 0xb3, 0xb0, 0x03, 0x18 };
	const unsigned char stopdma2[] = { 0xb4, 0x30, 0x03, 0x00 };
	const unsigned char stopdma3[] = { 0xb4, 0xb0, 0x00, 0x00 };
	const unsigned char stopdma4[] = { 0xb5, 0x30, 0x03, 0x18 };
	const unsigned char stopdma5[] = { 0xb6, 0xb0, 0x00, 0x00 };
	const unsigned char stopdma6[] = { 0xbb, 0xb0, 0x03, 0x18 };
	const unsigned char stopdma7[] = { 0xbc, 0x30, 0x03, 0x00 };
	const unsigned char stopdma8[] = { 0xb0, 0x60, 0x00, 0x00 };
	
	// Freeze DSP
	I2C_RandomWrite(MASF_ID, MAS_DSP, freeze, 2);
	
	// Stop all internal DMA transfers
	I2C_RandomWrite(MASF_ID, MAS_DSP, stopdma1, 4);
	I2C_RandomWrite(MASF_ID, MAS_DSP, stopdma2, 4);
	I2C_RandomWrite(MASF_ID, MAS_DSP, stopdma3, 4);
	I2C_RandomWrite(MASF_ID, MAS_DSP, stopdma4, 4);
	I2C_RandomWrite(MASF_ID, MAS_DSP, stopdma5, 4);
	I2C_RandomWrite(MASF_ID, MAS_DSP, stopdma6, 4);
	I2C_RandomWrite(MASF_ID, MAS_DSP, stopdma7, 4);
	I2C_RandomWrite(MASF_ID, MAS_DSP, stopdma8, 4);
}

static const unsigned char confmem[] = { 0xb6, 0xbc, 0x00, 0x00 };
static const unsigned char runi2s[]  = { 0x10, 0x00 };

void MAS_Download_MASPCM( void )
{
	int i;
	
	MAS_Freeze();
	
	// Download program to MAS memory
	for ( i = 0; i < MASPCM_ARRAYNUM; i++ )
		I2C_RandomWrite(MASF_ID, MAS_DSP, maspcm_array_p[i], maspcm_array_l[i] );

	I2C_RandomWrite(MASF_ID, MAS_DSP, confmem, 4);	// Reconfigure data to program memory
	I2C_RandomWrite(MASF_ID, MAS_DSP, runi2s, 2);	// Start execution at D0:1000
	
	MAS_Idle();
}

void MAS_Idle( void )
{
	unsigned int mas;
			
	// stop whatever we do
	MAS_WriteD0( PCM_IOC_MAIN, 0x0125 );

	do {
		unsigned int mas;
		MAS_ShortReadD0( PCM_APP_RUN, &mas, 1 );
	} while( mas != 0 );

} 	

